#include "misc.h"

FILE* outfile = 0;
int method = 0;

void info_initial(int target, char* filename){
	method = target;
	if(method & 2)
		outfile = fopen(filename, "w");
}

void info(char *fmt,...) {
	va_list ap;
	va_start(ap,fmt);
	if( (method & 2) && outfile)
		vfprintf(outfile, fmt,ap);
	va_end(ap);

	va_start(ap,fmt);
	if( method & 1)
		vfprintf(stdout, fmt,ap);
	va_end(ap);
}

void info_flush() {
	if((method & 2) && outfile)
		fflush(outfile);
	if(method & 1)
		fflush(stdout);
}

void info_terminate(){
	if((method & 2) && outfile){
		fclose(outfile);
	}
	outfile =  0;
	method = 0;
}

/*
template <class T> inline void swap(T& x, T& y) { T t=x; x=y; y=t; }
template <class S, class T> inline void clone(T*& dst, S* src, int n)
{
	dst = new T[n];
	memcpy((void *)dst,(void *)src,sizeof(T)*n);
}
*/
