#ifndef MISC_H
#define MISC_H

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>

#define Malloc(type,n) (type *)malloc((n)*sizeof(type))

void info_initial(int target, char* filename);
void info(char *fmt,...);
void info_flush();
void info_terminate();

#ifndef min
template <class T> inline T min(T x,T y) { return (x<y)?x:y; }
#endif
#ifndef max
template <class T> inline T max(T x,T y) { return (x>y)?x:y; }
#endif

#endif
